=== debian/changelog ===
reflect-cpp (0.21.0+ds-2) unstable; urgency=medium

  * d/patches: add patch to fix compatibility with yyjson 0.12.
    (closes: #1117428)

 -- Shengqi Chen <harry@debian.org>  Fri, 24 Oct 2025 17:26:42 +0800

reflect-cpp (0.21.0+ds-1) unstable; urgency=medium

  * New upstream version 0.21.0+ds (closes: #1112554, #1113465).
    + d/: change SONAME to libreflectcpp0.21.
  * d/patches:
    + refresh existing patches.
    + update patch for new libbson-dev (closes: #1112052).
    + add patch to fix compatibility with pugixml < 1.15.
  * d/control: change B-D back to libtomlplusplus.
  * d/watch: switch to version 5.
  * d/rules:
    + remove CXXFLAGS due to warnings being fixed.
    + add CXXFLAGS to silence errors when building tests.

 -- Shengqi Chen <harry@debian.org>  Thu, 18 Sep 2025 19:15:19 +0800
