=== debian/watch ===
Version: 5
Template: GitHub
Owner: getml
Project: reflect-cpp
# skip (1) versions not starting with 'v'
MatchingPattern: https://api.github.com/repos/[^/]+/[^/]+/git/refs/tags/v((?:\d\.?)+)
RepackSuffix: +ds
